import { HTTPRequest, Page } from 'puppeteer';
interface ResolvableRequest extends HTTPRequest {
    pendingXhrResolver?: () => void;
}
export declare class PendingXHR {
    page: Page;
    resourceType: string;
    pendingXhrs: Set<HTTPRequest>;
    finishedWithSuccessXhrs: Set<HTTPRequest>;
    finishedWithErrorsXhrs: Set<HTTPRequest>;
    promisees: Promise<void>[];
    requestListener: (request: ResolvableRequest) => void;
    requestFailedListener: (request: ResolvableRequest) => void;
    requestFinishedListener: (request: ResolvableRequest) => void;
    constructor(page: Page);
    removePageListeners(): void;
    waitForAllXhrFinished(): Promise<void>;
    waitOnceForAllXhrFinished(): Promise<void>;
    pendingXhrCount(): number;
}
export {};
